#include <iostream>
#include <stdio.h>
#include <stdlib.h>

using namespace std;

int main()
{
    int n,k,i,j,l,x=0;
    scanf("%d%d",&n,&k);
    int perinaFarma[n][n];
    for(i=0;i<n;i++)
        for(j=0;j<n;j++)
            scanf("%d",&perinaFarma[i][j]);
    int brojSorti[k];
    int brojacSorti[k];
    int iPrvaTacka[k];
    int iDrugaTacka[k];
    int jPrvaTacka[k];
    int jDrugaTacka[k];
    for(i=0;i<k;i++)
    {
        iPrvaTacka[i]=-1;
        iDrugaTacka[i]=-1;
        jPrvaTacka[i]=-1;
        jDrugaTacka[i]=-1;
        brojSorti[i]=0;
        brojacSorti[i]=0;
    }
    for(i=0;i<n;i++)
        for(j=0;j<n;j++)
            brojSorti[perinaFarma[i][j]]++;
    for(l=1;l<=k;l++)
    {
        int b=0;
        for(i=0;i<n;i++)
            for(j=0;j<n;j++)
                if(perinaFarma[i][j]==l && b==0)
                {
                    b++;
                    iPrvaTacka[l]=i;
                    jPrvaTacka[l]=j;
                }
    }
    for(l=1;l<=k;l++)
    {
        int b=0;
        for(i=n-1;i>=0;i--)
            for(j=n-1;j>=0;j--)
                if(perinaFarma[i][j]==l && b==0)
                {
                    b++;
                    iDrugaTacka[l]=i;
                    jDrugaTacka[l]=j;
                }
    }
    for(l=1;l<=k;l++)
    {
        int a=0;
        if(brojSorti[l]==0)
            a++;
        for(i=iPrvaTacka[l];i<=iDrugaTacka[l];i++)
            for(j=jPrvaTacka[l];j<=jDrugaTacka[l];j++)
            {
                if(perinaFarma[i][j]!=l)
                {
                    a++;
                    break;
                }
                else
                    brojacSorti[l]++;
            }
        if(a==0 && brojSorti[l]==brojacSorti[l])
            x++;
    }
    int a=0;
    printf("%d",x);
    return 0;
}